<?php

namespace 1111\1111\Http\Controllers;

use App\Http\Controllers\AdminController as AdminController;
use Form;
use 1111\1111\Http\Requests\1111AdminRequest;
use 1111\1111\Interfaces\1111RepositoryInterface;
use 1111\1111\Models\1111;

/**
 * Admin controller class.
 */
class 1111AdminController extends AdminController
{
    /**
     * Initialize 1111 controller.
     *
     * @param type 1111RepositoryInterface $1111
     *
     * @return type
     */
    public function __construct(1111RepositoryInterface $1111)
    {
        parent::__construct();
        $this->repository = $1111;
    }

    /**
     * Display a list of 1111.
     *
     * @return Response
     */
    public function index(1111AdminRequest $request)
    {
        $1111s  = $this->repository->setPresenter('\\1111\\1111\\Repositories\\Presenter\\1111ListPresenter')
                                            ->scopeQuery(function($query){
                                                return $query->orderBy('id','DESC');
                                            })->paginate();
        $this   ->theme->prependTitle(trans('1111::1111.names').' :: ');
        $view   = $this->theme->of('1111::admin.1111.index')->render();

        $this->responseCode = 200;
        $this->responseMessage = trans('messages.success.loaded', ['Module' => trans('1111::1111.name')]);
        $this->responseData = $1111s['data'];
        $this->responseMeta = $1111s['meta'];
        $this->responseView = $view;
        $this->responseRedirect = '';
        return $this->respond($request);
    }

    /**
     * Display 1111.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function show(1111AdminRequest $request, 1111 $1111)
    {
        if (!$1111->exists) {
            $this->responseCode = 404;
            $this->responseMessage = trans('messages.success.notfound', ['Module' => trans('1111::1111.name')]);
            $this->responseView = view('1111::admin.1111.new');
            return $this -> respond($request);
        }

        Form::populate($1111);
        $this->responseCode = 200;
        $this->responseMessage = trans('messages.success.loaded', ['Module' => trans('1111::1111.name')]);
        $this->responseData = $1111;
        $this->responseView = view('1111::admin.1111.show', compact('1111'));
        return $this -> respond($request);
    }

    /**
     * Show the form for creating a new 1111.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function create(1111AdminRequest $request)
    {

        $1111 = $this->repository->newInstance([]);

        Form::populate($1111);

        $this->responseCode = 200;
        $this->responseMessage = trans('messages.success.loaded', ['Module' => trans('1111::1111.name')]);
        $this->responseData = $1111;
        $this->responseView = view('1111::admin.1111.create', compact('1111'));
        return $this -> respond($request);

    }

    /**
     * Create new 1111.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function store(1111AdminRequest $request)
    {
        try {
            $attributes = $request->all();
            $attributes['user_id'] = user_id();
            $1111 = $this->repository->create($attributes);

            $this->responseCode = 201;
            $this->responseMessage = trans('messages.success.created', ['Module' => trans('1111::1111.name')]);
            $this->responseData = $1111;
            $this->responseMeta = '';
            $this->responseRedirect = trans_url('/admin/1111/1111/'.$1111->getRouteKey());
            $this->responseView = view('1111::admin.1111.create', compact('1111'));

            return $this -> respond($request);

        } catch (Exception $e) {
            $this->responseCode = 400;
            $this->responseMessage = $e->getMessage();
            return $this -> respond($request);
        }
    }

    /**
     * Show 1111 for editing.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function edit(1111AdminRequest $request, 1111 $1111)
    {
        Form::populate($1111);
        $this->responseCode = 200;
        $this->responseMessage = trans('messages.success.loaded', ['Module' => trans('1111::1111.name')]);
        $this->responseData = $1111;
        $this->responseView = view('1111::admin.1111.edit', compact('1111'));

        return $this -> respond($request);
    }

    /**
     * Update the 1111.
     *
     * @param Request $request
     * @param int     $id
     *
     * @return Response
     */
    public function update(1111AdminRequest $request, 1111 $1111)
    {
        try {

            $attributes = $request->all();

            $1111->update($attributes);

            $this->responseCode = 204;
            $this->responseMessage = trans('messages.success.updated', ['Module' => trans('1111::1111.name')]);
            $this->responseData = $1111;
            $this->responseRedirect = trans_url('/admin/1111/1111/'.$1111->getRouteKey());

            return $this -> respond($request);

        } catch (Exception $e) {

            $this->responseCode = 400;
            $this->responseMessage = $e->getMessage();
            $this->responseRedirect = trans_url('/admin/1111/1111/'.$1111->getRouteKey());

            return $this -> respond($request);
        }
    }

    /**
     * Remove the 1111.
     *
     * @param int $id
     *
     * @return Response
     */
    public function destroy(1111AdminRequest $request, 1111 $1111)
    {

        try {

            $t = $1111->delete();

            $this->responseCode = 202;
            $this->responseMessage = trans('messages.success.deleted', ['Module' => trans('1111::1111.name')]);
            $this->responseRedirect = trans_url('/admin/1111/1111/0');

            return $this -> respond($request);

        } catch (Exception $e) {

            $this->responseCode = 400;
            $this->responseMessage = $e->getMessage();
            $this->responseRedirect = trans_url('/admin/1111/1111/'.$1111->getRouteKey());

            return $this -> respond($request);

        }
    }
}
