<?php

namespace 1111\1111\Http\Controllers;

use App\Http\Controllers\UserController as UserController;
use Form;
use 1111\1111\Http\Requests\1111UserRequest;
use 1111\1111\Interfaces\1111RepositoryInterface;
use 1111\1111\Models\1111;

class 1111UserController extends UserController
{
    /**
     * Initialize 1111 controller.
     *
     * @param type 1111RepositoryInterface $1111
     *
     * @return type
     */
    public function __construct(1111RepositoryInterface $1111)
    {
        $this->repository = $1111;
        parent::__construct();
    }

    /**
     * Display a listing of the resource.
     *
     * @return Response
     */
    public function index(1111UserRequest $request)
    {
        $this->repository->pushCriteria(new \Lavalite\1111\Repositories\Criteria\1111UserCriteria());
        $1111s = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        $this->theme->prependTitle(trans('1111::1111.names').' :: ');

        return $this->theme->of('1111::user.1111.index', compact('1111s'))->render();
    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     * @param 1111 $1111
     *
     * @return Response
     */
    public function show(1111UserRequest $request, 1111 $1111)
    {
        Form::populate($1111);

        return $this->theme->of('1111::user.1111.show', compact('1111'))->render();
    }

    /**
     * Show the form for creating a new resource.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function create(1111UserRequest $request)
    {

        $1111 = $this->repository->newInstance([]);
        Form::populate($1111);

        return $this->theme->of('1111::user.1111.create', compact('1111'))->render();
    }

    /**
     * Display the specified resource.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function store(1111UserRequest $request)
    {
        try {
            $attributes = $request->all();
            $attributes['user_id'] = user_id();
            $1111 = $this->repository->create($attributes);

            $this->responseCode = 201;
            $this->responseMessage = trans('messages.success.created', ['Module' => trans('1111::1111.name')]);
            $this->responseRedirect = trans_url('/user/1111/1111');
            return $this -> respond($request);
        } catch (Exception $e) {
            redirect()->back()->withInput()->with('message', $e->getMessage())->with('code', 400);
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Request $request
     * @param 1111 $1111
     *
     * @return Response
     */
    public function edit(1111UserRequest $request, 1111 $1111)
    {

        Form::populate($1111);

        return $this->theme->of('1111::user.1111.edit', compact('1111'))->render();
    }

    /**
     * Update the specified resource.
     *
     * @param Request $request
     * @param 1111 $1111
     *
     * @return Response
     */
    public function update(1111UserRequest $request, 1111 $1111)
    {
        try {
            $this->repository->update($request->all(), $1111->getRouteKey());
            $this->responseCode = 204;
            $this->responseMessage = trans('messages.success.updated', ['Module' => trans('1111::1111.name')]);
            $this->responseRedirect = trans_url('/user/1111/1111');
            return $this -> respond($request);
        } catch (Exception $e) {
            redirect()->back()->withInput()->with('message', $e->getMessage())->with('code', 400);
        }
    }

    /**
     * Remove the specified resource.
     *
     * @param int $id
     *
     * @return Response
     */
    public function destroy(1111UserRequest $request, 1111 $1111)
    {
        try {
            $this->repository->delete($1111->getRouteKey());
            $this->responseCode = 204;
            $this->responseMessage = trans('messages.success.deleted', ['Module' => trans('1111::1111.name')]);
            $this->responseRedirect = trans_url('/user/1111/1111');
            return $this -> respond($request);
        } catch (Exception $e) {

            redirect()->back()->withInput()->with('message', $e->getMessage())->with('code', 400);

        }
    }
}
